<?php
/*
  Plugin Name: ARForms - Mailster Integration
  Description: ARForms Extesnion for Mailster plugin to Subscriber users
  Version: 1.8
  Plugin URI: http://www.arformsplugin.com/
  Author: Repute InfoSystems
  Author URI: http://reputeinfosystems.com/
  Text Domain: ARForms-MyMail
 */

$arforms_mymail_plugin_dir_name = 'arformsmymail';


define( 'ARF_MYMAIL_DIR', WP_PLUGIN_DIR . '/' . $arforms_mymail_plugin_dir_name );
$arfsiteurl = home_url();
if ( is_ssl() and ( ! preg_match( '/^https:\/\/.*\..*$/', $arfsiteurl ) or ! preg_match( '/^https:\/\/.*\..*$/', WP_PLUGIN_URL ) ) ) {
	$arfsiteurl = str_replace( 'http://', 'https://', $arfsiteurl );
	define( 'ARF_MYMAIL_URL', str_replace( 'http://', 'https://', WP_PLUGIN_URL . '/arformsmymail' ) );
} else {
	define( 'ARF_MYMAIL_URL', WP_PLUGIN_URL . '/arformsmymail' );
}

load_plugin_textdomain( 'ARForms-MyMail', false, $arforms_mymail_plugin_dir_name . '/languages/' );

global $arformsmymail;
$arformsmymail = new ARF_MyMail();

global $arformsmymail_version;
$arformsmymail_version = '1.8';

global $arformsmymail_assets_version;
$arformsmymail_assets_version = $arformsmymail_version.'_'.rand(1,100);

global $arf_my_mail_shortname;
$arf_my_mail_shortname = 'ARFMYMAIL';

global $arf_forms_tbl, $arf_my_mail_forms_tbl, $mymail_form_fields_tbl, $mymail_subscribers_tbl, $mymail_lists_subscribers_tbl, $mymail_subscriber_fields_tbl, $wpdb;
$arf_forms_tbl                  = $wpdb->prefix . 'arf_forms';
$arf_my_mail_forms_tbl          = $wpdb->prefix . 'arf_my_mail_forms';
$mymail_forms_tbl               = $wpdb->prefix . 'mymail_forms';
$mymail_form_fields_tbl         = $wpdb->prefix . 'mymail_form_fields';
$mymail_subscribers_tbl         = $wpdb->prefix . 'mymail_subscribers';
$mymail_lists_subscribers_tbl   = $wpdb->prefix . 'mymail_lists_subscribers';
$mymail_subscriber_fields_tbl   = $wpdb->prefix . 'mymail_subscriber_fields';
$mailster_forms_tbl             = $wpdb->prefix . 'mailster_forms';
$mailster_form_fields_tbl       = $wpdb->prefix . 'mailster_form_fields';

class ARF_MyMail {

	function __construct() {

		add_action( 'init', array( $this, 'arformsmymail_db_check' ) );

		register_activation_hook( __FILE__, array( 'ARF_MyMail', 'install' ) );

		register_activation_hook( __FILE__, array( 'ARF_MyMail', 'arf_mymail_check_network_activation' ) );

		register_uninstall_hook( __FILE__, array( 'ARF_MyMail', 'uninstall' ) );

		add_action( 'admin_menu', array( $this, 'arformsmymail_menu' ), 27 );

		add_action( 'admin_notices', array( $this, 'arformsmymail_admin_notices' ) );

		add_action( 'admin_enqueue_scripts', array( $this, 'arf_set_js' ), 11 );

		add_action( 'admin_enqueue_scripts', array( $this, 'arf_set_css' ), 11 );

		add_action( 'wp_head', array( $this, 'arf_set_front_css') );

		add_action( 'admin_init', array( $this, 'upgrade_arformsmymail_data' ) );

		add_action( 'wp_ajax_arf_mymail_field_dropdown', array( $this, 'arf_mymail_field_dropdown' ) );

		add_action( 'wp_ajax_arf_get_mymail_form_fields', array( $this, 'arf_get_mymail_form_fields' ) );

		add_action( 'wp_ajax_arf_mymail_delete_form', array( $this, 'arf_mymail_delete_form' ) );

		add_action( 'arfbeforedestroyform', array( $this, 'arfdelete_mymail_form' ), 11, 1 );

		add_action( 'wp_ajax_arf_mymail_fill_list_fields', array( $this, 'arf_mymail_fill_list_fields' ), 10, 2 );

		add_filter( 'arf_check_for_draw_outside', array( $this, 'arf_mymail_fields_check_drawoutside' ), 10, 2 );

		add_filter( 'arf_drawthisfieldfromoutside', array( $this, 'arf_mymail_field_drawfieldvalue_v3' ), 10, 4 );

		add_filter( 'arf_predisplay_form', array( $this, 'arf_before_form_render_v3' ), 10, 2 );	

		add_action( 'arfaftercreateentry', array( $this, 'after_submit_form' ), 101, 2 );

		add_action( 'wp_ajax_arf_mymail_form_bulk_act', array( $this, 'arf_mymail_form_bulk_act' ) );

		add_filter( 'arf_is_validateform_outside', array( $this, 'arfmymail_validate_process' ), 10, 2 );

		add_filter( 'arf_validate_form_outside_errors', array( $this, 'arf_prevalidate_fields' ), 25, 4 );

		add_action( 'user_register', array( $this, 'arf_add_capabilities_to_new_user' ) );

		add_action( 'set_user_role', array( $this, 'ars_add_capabilities_change_user_role' ), 10, 3 );

		add_action( 'wp_ajax_arf_save_mailster_form_data', array( $this, 'arf_save_mailster_form_data_callback') );

		add_action( 'arf_after_paypal_successful_paymnet', array( $this, 'arf_mailster_after_paypal_submit'), 21, 3);
	}

	function ars_add_capabilities_change_user_role( $user_id, $role, $old_roles ) {
		if ( $user_id == '' ) {
			return;
		}
		if ( $role == 'administrator' && $user_id ) {
			$arf_mymail_roles = $mymailcapabilities = array(
				'arformsmymail' => esc_html__( 'Configure ARForms Mailster', 'ARForms-MyMail' ),
			);
			;
			$userObj = new WP_User( $user_id );
			foreach ( $arf_mymail_roles as $arf_mymail_role => $arf_mymail_roledescription ) {
				if ( ! user_can( $user_id, $arf_mymail_role ) ) {
					$userObj->add_cap( $arf_mymail_role );
				}
			}
			unset( $arf_mymail_role );
			unset( $arf_mymail_roles );
			unset( $arf_mymail_roledescription );
		}
	}

	public static function arf_mymail_check_network_activation( $network_wide ) {
		if ( ! $network_wide ) {
			return;
		}
		deactivate_plugins( plugin_basename( __FILE__ ), true, true );
		header( 'Location: ' . network_admin_url( 'plugins.php?deactivate=true' ) );
		exit;
	}

	function arf_add_capabilities_to_new_user( $user_id ) {
		if ( $user_id == '' ) {
			return;
		}
		if ( user_can( $user_id, 'administrator' ) ) {

			$mymailcapabilities = array(
				'arformsmymail' => esc_html__( 'Configure ARForms Mailster', 'ARForms-MyMail' ),
			);
			$arfroles  = $mymailcapabilities;
			$userObj   = new WP_User( $user_id );
			foreach ( $arfroles as $arfrole => $arfroledescription ) {
				$userObj->add_cap( $arfrole );
			}
			unset( $arfrole );
			unset( $arfroles );
			unset( $arfroledescription );
		}
	}

	public static function arformsmymail_db_check() {
		global $arformsmymail;
		$arformsmymail_version = get_option( 'arformsmymail_version' );

		if ( ! isset( $arformsmymail_version ) || $arformsmymail_version == '' ) {
			$arformsmymail->install();
		}
	}

	public static function install() {
		$arformsmymail_version = get_option( 'arformsmymail_version' );
		if ( ! isset( $arformsmymail_version ) || $arformsmymail_version == '' ) {
			global $wpdb, $arformsmymail_version,$arf_my_mail_forms_tbl;
			update_option( 'arformsmymail_version', $arformsmymail_version );
			$charset_collate = '';
			if ( ! empty( $wpdb->charset ) ) {
				$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
			}
			if ( ! empty( $wpdb->collate ) ) {
				$charset_collate .= " COLLATE $wpdb->collate";
			}
			if ( file_exists( ABSPATH . 'wp-admin/includes/upgrade.php' ) ) {
				require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
			}

			$table_name = $arf_my_mail_forms_tbl;

			$sql = "CREATE TABLE {$table_name} (
					id int(11) NOT NULL auto_increment,
					form_id int(11) NOT NULL,
					form_name varchar(255) default NULL,
					options longtext default NULL,
					created_at datetime NOT NULL,
					PRIMARY KEY (id)
				  ) {$charset_collate};";
			dbDelta( $sql );
		}

		$args = array(
			'role' => 'administrator',
			'fields' => 'id',
		);
		$users = get_users( $args );
		if ( count( $users ) > 0 ) {
			foreach ( $users as $key => $user_id ) {
				$mymailcapabilities = array(
					'arformsmymail' => esc_html__( 'Configure ARForms Mailster', 'ARForms-MyMail' ),
				);

				$arfroles  = $mymailcapabilities;
				$userObj   = new WP_User( $user_id );
				foreach ( $arfroles as $arfrole => $arfroledescription ) {
					$userObj->add_cap( $arfrole );
				}
				unset( $arfrole );
				unset( $arfroles );
				unset( $arfroledescription );
			}
		}
	}

	public static function uninstall() {
		global $wpdb,$arf_my_mail_forms_tbl;
		if ( is_multisite() ) {
			$blogs = $wpdb->get_results( "SELECT blog_id FROM {$wpdb->blogs}", ARRAY_A );
			if ( $blogs ) {
				foreach ( $blogs as $blog ) {
					switch_to_blog( $blog['blog_id'] );
					delete_option( 'arformsmymail_version' );
					delete_option( 'arfmymail_update_token' );
					$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_my_mail_forms_tbl );
				}
				restore_current_blog();
			}
		} else {
			delete_option( 'arformsmymail_version' );
			delete_option( 'arfmymail_update_token' );
			$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_my_mail_forms_tbl );
		}
	}

	function arfmymail_getapiurl() {
		$api_url = 'https://www.arpluginshop.com/';
		return $api_url;
	}

	function arfmymail_get_remote_post_params( $plugin_info = '' ) {
		global $wpdb, $arfversion;

		$action = '';
		$action = $plugin_info;

		if ( ! function_exists( 'get_plugins' ) ) {
			require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
		}
		$plugin_list = get_plugins();
		$site_url    = home_url();
		$plugins     = array();

		$active_plugins = get_option( 'active_plugins' );

		foreach ( $plugin_list as $key => $plugin ) {
			$is_active = in_array( $key, $active_plugins );
			if ( strpos( strtolower( $plugin['Title'] ), 'arformsmymail' ) !== false ) {
				$name = substr( $key, 0, strpos( $key, '/' ) );
				$plugins[] = array(
					'name' => $name,
					'version' => $plugin['Version'],
					'is_active' => $is_active,
				);
			}
		}
		$plugins            = json_encode( $plugins );
		$theme              = wp_get_theme();
		$theme_name         = $theme->get( 'Name' );
		$theme_uri          = $theme->get( 'ThemeURI' );
		$theme_version      = $theme->get( 'Version' );
		$theme_author       = $theme->get( 'Author' );
		$theme_author_uri   = $theme->get( 'AuthorURI' );

		$im = is_multisite();
		$sortorder = get_option( 'arfSortOrder' );

		$post = array(
			'wp' => get_bloginfo( 'version' ),
			'php' => phpversion(),
			'mysql' => $wpdb->db_version(),
			'plugins' => $plugins,
			'tn' => $theme_name,
			'tu' => $theme_uri,
			'tv' => $theme_version,
			'ta' => $theme_author,
			'tau' => $theme_author_uri,
			'im' => $im,
			'sortorder' => $sortorder,
		);

		return $post;
	}

	function arformsmymail_admin_notices() {
		global $arformsmymail,$wp_version;

		if( version_compare($wp_version, '4.5.0', '<') ){
			deactivate_plugins( __FILE__, false, null );
			echo "<div class='updated'><p>Please meet the minimum requirement of WordPress version 4.5 to activate ARForms - Mailster Integration Add-on</p></div>";
		}

		if ( ! $arformsmymail->is_arforms_support() ) {
			echo "<div class='updated'><p>" . esc_html__( 'Mailster Integration With ARForms plugin requires ARForms Plugin installed and active.', 'ARForms-MyMail' ) . '</p></div>';
		} else if ( ! version_compare( $arformsmymail->get_arforms_version(), '2.6', '>=' ) ) {
			echo "<div class='updated'><p>" . esc_html__( 'Mailster Integration With ARForms plugin requires ARForms plugin installed with version 2.6 or higher.', 'ARForms-MyMail' ) . '</p></div>';
		} else if ( ! class_exists( 'mymail' ) && ! class_exists( 'mailster' ) ) {
			echo "<div class='updated'><p>" . esc_html__( 'Mailster Integration With ARForms plugin requires Mailster plugin installed.', 'ARForms-MyMail' ) . '</p></div>';
		}
	}

	function is_arforms_support() {
		if ( file_exists( ABSPATH . 'wp-admin/includes/plugin.php' ) ) {
			include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
		}
		return is_plugin_active( 'arforms/arforms.php' );
	}

	function get_arforms_version() {
		$arf_db_version = get_option( 'arf_db_version' );
		return ( isset( $arf_db_version ) ) ? $arf_db_version : 0;
	}

	function route() {

		global $arformsmymail;
		
		if ( isset( $_REQUEST['page'] ) and $_REQUEST['page'] == 'ARForms-Mailster' and isset( $_REQUEST['arfaction'] ) and ( $_REQUEST['arfaction'] == 'new' || $_REQUEST['arfaction'] == 'edit' ) ) {
			return $arformsmymail->new_form_v3();
		} else {
			return $arformsmymail->list_forms();
		}
	}

	function arf_get_mailster_data() {

		if ( file_exists( WP_PLUGIN_DIR . '/mailster/mailster.php' ) && is_plugin_active( 'mailster/mailster.php' ) ) {

			$mailster_data = get_plugin_data( WP_PLUGIN_DIR . '/mailster/mailster.php' );
			$mailster_version = $mailster_data['Version'];
			return $mailster_version;
		}
		return false;
	}

	function arformsmymail_menu() {
		global $arformsmymail;
		if ( version_compare( $arformsmymail->get_arforms_version(), '2.6', '>=' ) && ( is_plugin_active( 'mailster/mailster.php' ) || is_plugin_active( 'myMail/myMail.php' ) ) ) {

			global $arfsettings;
			add_submenu_page( 'ARForms', 'ARForms | ' . esc_html__( 'Mailster Configuration', 'ARForms-MyMail' ), esc_html__( 'Mailster Configuration', 'ARForms-MyMail' ), 'arformsmymail', 'ARForms-Mailster', array( $this, 'route' ) );
		}
	}

	function arf_set_js() {
		global $arformsmymail_assets_version;
		wp_register_script( 'arformsmymail-js', ARF_MYMAIL_URL . '/js/arformsmymail.js', array( 'jquery' ), $arformsmymail_assets_version );
		wp_register_script( 'bootstrap', ARFURL . '/bootstrap/js/bootstrap.min.js', array( 'jquery' ), $arformsmymail_assets_version );
		wp_register_script( 'tipso', ARFURL . '/js/tipso.min.js', array( 'jquery' ) );
		wp_register_script( 'jquery_dataTables', ARFURL . '/datatables/media/js/jquery.dataTables.js', array(), $arformsmymail_assets_version );
		wp_register_script( 'ColVis', ARFURL . '/datatables/media/js/ColVis.js', array(), $arformsmymail_assets_version );
		wp_register_script( 'FixedColumns', ARFURL . '/datatables/media/js/FixedColumns.js', array(), $arformsmymail_assets_version );

		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' && $_REQUEST['page'] == 'ARForms-Mailster' ) {
			wp_enqueue_script( 'arformsmymail-js' );

			wp_enqueue_script( 'bootstrap' );

			wp_enqueue_script( 'jquery' );

			wp_enqueue_script( 'jquery_dataTables' );

			wp_enqueue_script( 'ColVis' );

			wp_enqueue_script( 'FixedColumns' );

			wp_enqueue_script( 'tipso' );
		}


		$script_data  = "
			var __NO_VALID_ACTION_MSG='". esc_html__('Please select valid action.', 'ARForms-MyMail') ."';
        	
        	var __SELECT_ONE_OR_MORE_FILE_MSG='". esc_html__('Please select one or more record to perform action.', 'ARForms-MyMail') ."';

		    var __DEL_CONF_MSG='". sprintf(addslashes(esc_html__('Are you sure you want to %s delete this configuration?', 'ARForms-MyMail')), '<br />')."';
		    var __ARF_DELETE_TEXT = '".addslashes(esc_html__('Delete','ARForms-MyMail')) ."';

            var __ARF_CANCEL_TEXT = '".addslashes(esc_html__('Cancel','ARForms-MyMail')) ."';

            var __ADD_RULE_MSG = '".addslashes(esc_html__('Please add one or more rules','ARForms-MyMail')) ."';
		";
		
		wp_add_inline_script( 'arformsmymail-js', $script_data );
	}

	function arf_set_css( $hook ) {
		global $arformsmymail_assets_version;
		
		wp_register_style( 'arformsmymail-css', ARF_MYMAIL_URL . '/css/arformsmymail.css', array(), $arformsmymail_assets_version );
		
		wp_register_style( 'bootstrap', ARFURL . '/bootstrap/css/bootstrap.css', array(), $arformsmymail_assets_version );
		
		wp_register_style( 'tipso', ARFURL . '/css/tipso.min.css' );

		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' && $_REQUEST['page'] == 'ARForms-Mailster' ) {
			wp_enqueue_style( 'arformsmymail-css' );

			wp_enqueue_style( 'bootstrap' );
			
			wp_enqueue_style( 'tipso' );

			$internal_style = '.wp-admin .frm_catlevel_2, .wp-admin .frm_catlevel_3, .wp-admin .frm_catlevel_4, .wp-admin .frm_catlevel_5{margin-left:18px;}
                #arf_mymail_setting .lblsubtitle{
                    font-family: Asap-regular;
                    font-size: 14px !important;
                    color: #4e5462;
                    font-weight: normal !important;
                    padding-top: 11px;
                    display: inline-block;
                }
                #arf_mymail_setting .lbltitle {
                    font-family: Asap-medium;
                    font-size: 16px !important;
                    color: #4e5462;
                    font-weight: normal !important;
                }
                .lbltitle.titleclass {
                    padding: 50px 0px 20px 50px;
                }';

			wp_add_inline_style( 'arformsmymail-css', $internal_style );
		}

		if( isset($hook) && 'plugins.php' == $hook ){
			global $wp_version;
			if( version_compare($wp_version, '4.5.0', '<') ){
				deactivate_plugins( __FILE__ , false, null );
				$redirect_url = network_admin_url( 'plugins.php?deactivate=true' );
				wp_die( '<div class="arf_mailster_wp_notice"><p class="arf_mailster_wp_notice_text" >Please meet the minimum requirement of WordPress version 4.5 to activate ARForms - Mailster Integration Add-on<p class="arf_mailster_wp_notice_continue">Please <a href="javascript:void(0)" onclick="window.location.href=\'' . $redirect_url . '\'">Click Here</a> to continue.</p></div>' );
			}
		}
	}

	function list_forms( $message = '' ) {
		if ( file_exists( ARF_MYMAIL_DIR . '/core/list_forms_3.0.php' ) ) {
			require( ARF_MYMAIL_DIR . '/core/list_forms_3.0.php' );
		}
	}

	function upgrade_arformsmymail_data() {

		global $newarformsmymail_version;

		if ( ! isset( $newarformsmymail_version ) || $newarformsmymail_version == '' ) {
			$newarformsmymail_version = get_option( 'arformsmymail_version' );
		}

		if ( version_compare( $newarformsmymail_version, '1.8', '<' ) ) {
			$path = ARF_MYMAIL_DIR . '/core/upgrade_arformsmymail_latest_data.php';
			if ( file_exists( $path ) ) {
				include( $path );
			}
		}
	}

	function get_mapped_form_name( $form_id ) {
		global $wpdb, $arformsmymail,$arf_my_mail_forms_tbl;

		if ( ! $form_id ) {
			return;
		}

		$result = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' WHERE id = %d', $form_id ) );
		if ( $result ) {
			$result = $result[0];
			return isset( $mapped_with_array[ $result->mapped_with ] ) ? $mapped_with_array[ $result->mapped_with ] : '';
		}
	}

	function field_dropdown_v3( $form_id, $name = '', $class = '', $default_value = '', $id = '' ) {

		global $arffield, $MdlDb, $armainhelper;

		$field_list = array();

		if ( is_numeric( $form_id ) ) {
			if ( ! isset( $GLOBALS['arf_form_mailster_fields_data'][ $form_id ] ) ) {
				$exclude = "'divider','section','arf_repeater','captcha','break','html','like'";
				$field_list = $arffield->getAll( 'fi.type not in (' . $exclude . ') and fi.form_id=' . (int) $form_id, 'id' );
				$GLOBALS['arf_form_mailster_fields_data'][ $form_id ] = $field_list;
			} else {
				$field_list = $GLOBALS['arf_form_mailster_fields_data'][ $form_id ];
			}
		}
		?>

		<div class="sltstandard">
			<?php

			$selected_list_id = '';
			$selected_list_label = esc_html__( 'Select Field', 'ARForms-MyMail' );
			$list_of_form = '';
			foreach ( $field_list as $field ) {
				if( isset( $field->field_options['parent_field_type'] ) && 'arf_repeater' == $field->field_options['parent_field_type'] ){
					continue;
				}
				if ( $field->id == $default_value ) {
					$selected_list_id    = $field->id;
					$selected_list_label = $armainhelper->truncate( $field->name, 33 );
				}
				$list_of_form .= '<li class="arf_selectbox_option" data-value="' . $field->id . '" data-label="' . $armainhelper->truncate( $field->name, 33 ) . '">' . $armainhelper->truncate( $field->name, 33 ) . '</li>';
			}
			?>
			<input name="<?php echo esc_attr( $name ); ?>" id="<?php if ( $id == '' ) { echo esc_html( $name ); } else { echo esc_html( $id ); } ?>" value="<?php echo esc_html( $selected_list_id ); ?>" type="hidden">

			<dl class="arf_selectbox arf_mlstr_form_dd" data-name="<?php echo esc_html( $name ); ?>" data-id="<?php echo esc_html( $name ); ?>">
			   <dt>
			   		<span><?php echo $selected_list_label; ?></span>
			   		<input value="<?php echo esc_html( $selected_list_id ); ?>" class="arf_autocomplete" type="text">
				   	<svg viewBox="0 0 2000 1000" width="15px" height="15px">
					   	<g fill="#000">
							<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
					   	</g>
				   	</svg>
			   </dt>
			   <dd>
				   <ul data-id="<?php echo esc_html( $name ); ?>" class="<?php echo esc_attr( $class ); ?> frm-dropdown" id="<?php echo esc_html( $name . '_name' ); ?>">
					   <li class="arf_selectbox_option" data-value="" data-label=" <?php esc_html_e( 'Select Field', 'ARForms-MyMail' );?>"><?php esc_html_e( 'Select Field', 'ARForms-MyMail' ); ?></li>
					 	<?php echo $list_of_form; ?>
				   </ul>
			   </dd>
		    </dl>
		</div>
		<?php
	}

	function arf_mymail_field_dropdown() {
		global $arffield, $MdlDb, $armainhelper;

		$form_id = $_REQUEST['form_id'];
		$field_list = array();

		if ( is_numeric( $form_id ) ) {
			$exclude = "'divider','section','arf_repeater','captcha','break','html','like'";
			$field_list = $arffield->getAll( 'fi.type not in (' . $exclude . ') and fi.form_id=' . (int) $form_id, 'id' );
		} ?>

		<li class="arf_selectbox_option" data-value="" data-label="<?php esc_html_e( 'Select Field', 'ARForms-MyMail' ); ?>"><?php esc_html_e( 'Select Field', 'ARForms-MyMail' ); ?></li>
		<?php
		if ( count( $field_list ) > 0 ) {
			foreach ( $field_list as $field ) {
				if( isset( $field->field_options['parent_field_type'] ) && 'arf_repeater' == $field->field_options['parent_field_type'] ){
					continue;
				}
				?>
				<li class="arf_selectbox_option" data-value="<?php echo esc_html( $field->id ); ?>" data-label="<?php echo $armainhelper->truncate( $field->name, 33 ); ?>"><?php echo $armainhelper->truncate( $field->name, 33 ); ?></li>                    
				<?php
			}
		}
		
		die();
	}

	function arf_mymail_fill_list_fields( $form_id_get = '', $selected_values = '' ) {
		global $arffield, $MdlDb, $armainhelper;

		if ( $form_id_get == '' ) {
			$form_id = $_REQUEST['form_id'];
		} else {
			$form_id = $form_id_get;
		}

		$field_list = array();

		if ( is_numeric( $form_id ) ) {
			$include = "'checkbox','select', 'radio'";

			$field_list = $arffield->getAll( 'fi.type in (' . $include . ') and fi.form_id=' . (int) $form_id, 'id' );
		} ?>

		<li class="arf_selectbox_option" data-value="" data-label="
			<?php
			esc_html_e( 'Select Field', 'ARForms-MyMail' );
			;
			?>
			"><?php esc_html_e( 'Select Field', 'ARForms-MyMail' ); ?>
		</li>
			
		<?php
		if ( count( $field_list ) > 0 ) {
			foreach ( $field_list as $field ) {
				if( isset( $field->field_options['parent_field_type'] ) && 'arf_repeater' == $field->field_options['parent_field_type'] ){
					continue;
				}
				?>
				<li class="arf_selectbox_option" data-value="<?php echo esc_html( $field->id ); ?>" data-label="<?php echo $armainhelper->truncate( $field->name, 33 ); ?>"><?php echo $armainhelper->truncate( $field->name, 33 ); ?></li>                    
				<?php
			}
		}
		
		if ( $form_id_get == '' ) {
			die();
		}
	}

	function arf_get_mymail_form_fields() {
		global $arffield, $MdlDb, $armainhelper, $arformsmymail;

		$mymail_form_id = $_REQUEST['mymail_form_id'];

		$form_id = $_REQUEST['form_id'];

		$field_list = array();

		if ( is_numeric( $mymail_form_id ) ) {
			$mymail_forms = $arformsmymail->get_my_mail_forms();
			if ( count( $mymail_forms[ $mymail_form_id ]['order'] ) > 0 ) {
				foreach ( $mymail_forms[ $mymail_form_id ]['order'] as $key => $value ) {
					$is_field_required = '';
					?>
					<tr class="tdclass">
						<td valign="top" width="18%" class="tdclass">
							<label class="lblsubtitle"><?php echo $mymail_forms[ $mymail_form_id ]['labels'][ $value ]; ?>
																  <?php
																	if ( in_array( $value, $mymail_forms[ $mymail_form_id ]['required'] ) ) {
																		$is_field_required = ' arfmymailrequiredfield';
																		?>
								<span class="arfglobalrequiredfield arf_mlstr_valign_middle">*</span>
																		<?php
																	}
																	?>
							</label>
						</td>
						<td>
							<div id="main_arf_mymail_<?php echo esc_html( $value ); ?>" class="arf_form_dropdown arf_mymail_<?php echo esc_attr( $value ); ?>  <?php echo esc_html( $is_field_required ); ?>">
								<div class="sltstandard">
								<?php
								
								echo $arformsmymail->field_dropdown_v3( $form_id, 'arf_mymail_' . $value, 'frm-dropdown arf_mymail_' . $value . ' arf_mymail_fields', $values[ 'arf_mymail_' . $value ] );
								
								?>
								</div>
							</div>
							<div class="arferrmessage arf_mlstr_field_error" id="main_arf_mymail_<?php echo esc_html( $value ); ?>_msg" ><?php esc_html_e( 'This field cannot be blank.', 'ARForms-MyMail' ); ?></div>
						</td>
					</tr>
								<?php
				}
			}
		}
		die();
	}

	function get_my_mail_forms() {
		global $wpdb,$mailster_forms_tbl,$mailster_form_fields_tbl,$mymail_forms_tbl,$mymail_form_fields_tbl;
		if ( is_plugin_active( 'mailster/mailster.php' ) ) {
			$mailster_version = get_option( 'mailster_version' );
			$new_version = 'yes';
			$tbl_forms = $mailster_forms_tbl;
			$tbl_form_fields = $mailster_form_fields_tbl;
		} else {
			$mymail_version = get_option( 'mymail_version' );
			$new_version = 'no';
			if ( ! version_compare( $mymail_version, '2.1', '>=' ) ) {
				$new_version = 'no';
			} else {
				$new_version = 'yes';
			}
			$tbl_forms = $mymail_forms_tbl;
			$tbl_form_fields = $mymail_form_fields_tbl;
		}

		if ( $new_version == 'yes' ) {

			$as_forms = $wpdb->get_results( 'SELECT ID,name,doubleoptin FROM ' . $tbl_forms . ' ORDER BY ID DESC ', ARRAY_A );

			$as_forms_filed = array();
			if ( isset( $as_forms ) && ! empty( $as_forms ) ) {
				foreach ( $as_forms as $key => $forms ) {
					$as_filed_order = $as_filed_labels = $as_filed_required = array();
						$as_filed = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $tbl_form_fields . ' WHERE form_id = %d ORDER BY position ASC ', $forms['ID'] ), ARRAY_A );

					if ( isset( $as_filed ) && ! empty( $as_filed ) ) {
						foreach ( $as_filed as $k => $filed ) {
							$as_filed_order[] = $filed['field_id'];
							$as_filed_labels[ $filed['field_id'] ] = $filed['name'];

							if ( ( isset( $filed['required'] ) && ! empty( $filed['required'] ) ) ) {
								$as_filed_required[] = $filed['field_id'];
							}
						}
					}

					$as_forms_filed[ $forms['ID'] ] = array(
						'id' => $forms['ID'],
						'name' => $forms['name'],
						'order' => $as_filed_order,
						'labels' => $as_filed_labels,
						'required' => $as_filed_required,
						'double_opt_in' => $forms['doubleoptin']
					);
				}
			}

			$mymail_forms = $as_forms_filed;
		} else {
			$mymail_options = get_option( 'mymail_options' );
			$mymail_forms = $mymail_options['forms'];
		}

		return $mymail_forms;
	}

	function get_my_mail_lists() {
		$mailster_version = $this->arf_get_mailster_data();
		
		if ( version_compare( $mailster_version, '2.3', '<' ) ) {
			$lists = mymail( 'lists' )->get();
		} else {
			$lists = mailster( 'lists' )->get();
		}
		return $lists;
	}



	function arf_mymail_delete_form() {
		global $arformsmymail;
		$id = $_POST['id'];
		$action = $_POST['act'];
		if ( $action == 'delete' && $id ) {
			$res = $arformsmymail->delete_forms( $id );
			$message = esc_html__( 'Record is deleted successfully.', 'ARForms-MyMail' );
			$errors = array();
			echo json_encode(
				array(
					'errors' => $errors,
					'message' => $message,
					'gridData' => $this->arf_get_mailster_form_data()
				)
			);
		}
		die();
	}

	function delete_forms( $id = 0 ) {
		if ( $id == 0 ) {
			return;
		}
		if ( $id ) {
			global $wpdb,$arf_my_mail_forms_tbl;
			$form = $wpdb->get_results( $wpdb->prepare( 'SELECT form_id FROM ' . $arf_my_mail_forms_tbl . ' WHERE id = %d', $id ) );
			$form = $form[0];

			if ( isset( $form->form_id ) and $form->form_id != '' ) {
				$res = $wpdb->query( $wpdb->prepare( 'DELETE FROM ' . $arf_my_mail_forms_tbl . ' WHERE id = %d', $id ) );
			}

			return $res;
		}
	}

	function arfdelete_mymail_form( $form_id ) {
		global $wpdb, $db_record,$arf_my_mail_forms_tbl;

		if ( ! $form_id ) {
			return;
		}
		$res = $wpdb->query( $wpdb->prepare( 'DELETE FROM ' . $arf_my_mail_forms_tbl . ' WHERE form_id = %d', $form_id ) );
	}

	function arf_mymail_form_bulk_act() {

		if ( ! isset( $_POST ) ) {
			return;
		}

		global $arfform,$arformsmymail,$armainhelper;

		$check_cap = $this->arf_mymail_check_user_cap( 'arformsmymail', true );
		$errors = array();

		if ( $check_cap != 'success' ) {
			$cap_msg = json_decode( $check_cap, true );
			array_push( $errors, $cap_msg[0] );
		}

		$bulkaction = $armainhelper->get_param( 'action1' );
		$message = '';

		if ( $bulkaction == -1 ) {
			$bulkaction = $armainhelper->get_param( 'action2' );
		}

		if ( ! empty( $bulkaction ) and strpos( $bulkaction, 'bulk_' ) === 0 ) {

			if ( isset( $_GET ) and isset( $_GET['action1'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action1'], '', $_SERVER['REQUEST_URI'] );
			}

			if ( isset( $_GET ) and isset( $_GET['action2'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action2'], '', $_SERVER['REQUEST_URI'] );
			}

			$bulkaction = str_replace( 'bulk_', '', $bulkaction );
		} else {

			$bulkaction = '-1';

			if ( isset( $_POST['bulkaction'] ) and $_POST['bulkaction1'] != '-1' ) {
				$bulkaction = $_POST['bulkaction1'];

			} else if ( isset( $_POST['bulkaction2'] ) and $_POST['bulkaction2'] != '-1' ) {
				$bulkaction = $_POST['bulkaction2'];
			}
		}

		$ids = $armainhelper->get_param( 'item-action', '' );

		if ( empty( $ids ) ) {
			$errors[] = esc_html__( 'Please select one or more records.', 'ARForms-MyMail' );
		} else {
			if ( ! is_array( $ids ) ) {
				$ids = explode( ',', $ids );
			}

			if ( is_array( $ids ) ) {
				if ( $bulkaction == 'delete' ) {

					foreach ( $ids as $fid ) {
						$res_var = $arformsmymail->delete_forms( $fid );
					}

					if ( $res_var ) {
						$message = esc_html__( 'Record is deleted successfully.', 'ARForms-MyMail' );
					}
				}
			}
		}

		$gridData = $this->arf_get_mailster_form_data();

		echo json_encode(
			array(
				'errors' => $errors,
				'message' => $message,
				'gridData' => $gridData
			)
		);

		die();
	}

	function arf_get_mailster_form_data(){
		global $wpdb,$db_record,$arf_my_mail_forms_tbl,$arf_forms_tbl;

		$forms = $wpdb->get_results( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' ORDER BY id DESC' );

		$rowData = array();

		if( is_array( $forms ) && count( $forms ) > 0 ){
			$n = 0;
			foreach( $forms as $form ){
				if( ! isset( $rowData[$n] ) ){
					$rowData[$n] = array();
				}

				$options = maybe_unserialize( $form->options );

				$rowData[$n][] = "<div class='arf_custom_checkbox_wrapper arfmarginl15'><input id='cb-item-action-".$form->id."' class='' type='checkbox' value='". $form->id."' name='item-action[]' /><svg width='18px' height='18px'><path id='arfcheckbox_unchecked' d='M15.205,16.852H3.774c-1.262,0-2.285-1.023-2.285-2.286V3.136  c0-1.263,1.023-2.286,2.285-2.286h11.431c1.263,0,2.286,1.023,2.286,2.286v11.43C17.491,15.829,16.467,16.852,15.205,16.852z   M15.49,2.851h-12v12h12V2.851z'></path><path id='arfcheckbox_checked' d='M15.205,16.852H3.774c-1.262,0-2.285-1.023-2.285-2.286V3.136  c0-1.263,1.023-2.286,2.285-2.286h11.431c1.263,0,2.286,1.023,2.286,2.286v11.43C17.491,15.829,16.467,16.852,15.205,16.852z   M15.49,2.851h-12v12h12V2.851z M5.93,6.997l2.557,2.558l4.843-4.843l1.617,1.616l-4.844,4.843l0.007,0.007l-1.616,1.616  l-0.007-0.007l-0.006,0.007l-1.617-1.616l0.007-0.007L4.314,8.614L5.93,6.997z'></path></svg></div><label for='cb-item-action-".$form->id."'><span></span></label>";

				$rowData[$n][] = $form->form_id;

				$rowData[$n][] = "<a class='row-title' href='" . wp_nonce_url( "?page-ARForms-Mailster&arfaction=edit&id=".$form->id ) . "'>" . $form->form_name . "</a>";

				$entries = $db_record->getRecordCount( $form->form_id );

				if( current_user_can( 'arfviewentries' ) ){
					$rowData[$n][] = "<a href='" . esc_url( admin_url( 'admin.php?page=ARForms-entries&form=' . $form->id ) ) . "'>" . $entries . "</a>";
				} else {
					$rowData[$n][] = $entries;
				}

				$rowData[$n][] = date( get_option( 'date_format' ), strtotime( $form->created_at ) );

				$action_btn  = "<div class='arf-row-actions'>";

					$edit_link = "?page=ARForms-Mailster&arfaction=edit&id=".$form->id;

					$action_btn .= "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Configuration', 'ARForms-MyMail' ) . "'>";
						$action_btn .= "<a href='" . wp_nonce_url( $edit_link ). "'>";
							$action_btn .= "<svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'>";
								$action_btn .= "<path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path>";
							$action_btn .= "</svg>";
						$action_btn .= "</a>";
					$action_btn .= "</div>";

					$action_btn .= "<div class='arfformicondiv arfhelptip arfdeleteform_div_" . $form->id . "' title='" . esc_html__( 'Delete', 'ARForms-MyMail' ) . "'>";
						$action_btn .= "<a class='arf_mailster_delete' onclick='arf_delete_mailster_entry(this);' data-id='" . $form->id . "'>";
							$action_btn .= "<svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg>";
						$action_btn .= "</a>";
					$action_btn .= "</div>";


				$action_btn .= "</div>";

				$rowData[$n][] = $action_btn;

				$n++;
			}
		}

		return $rowData;
	}

	function arf_save_mailster_form_data_callback(){
		global $wpdb, $arfform, $arformsmymail, $arf_forms_tbl, $arf_my_mail_forms_tbl;

		$check_cap = $this->arf_mymail_check_user_cap( 'arformsmymail', true );

		if( 'success' != $check_cap ){
			$cap_msg = json_decode( $check_cap, true );
			echo json_encode(
				array(
					'success' => false,
					'message' => $cap_msg[0]
				)
			);
			die;
		}

		$mymail_forms = $this->get_my_mail_forms();


		if( isset( $_REQUEST['id'] ) && '' != $_REQUEST['id'] && isset( $_REQUEST['arfaction'] ) && 'edit' == $_REQUEST['arfaction'] ){
			$id = $_REQUEST['id'];
			$arf_form_chk = $wpdb->get_results( $wpdb->prepare( 'SELECT id FROM ' . $arf_forms_tbl . ' WHERE id = %d', $_REQUEST['form_id'] ) );
			$form_chk = $wpdb->get_results( $wpdb->prepare( 'SELECT id FROM '. $arf_my_mail_forms_tbl . ' WHERE id = %d', $_REQUEST['id'] ) );

			if( !is_array( $arf_form_chk ) || count( $arf_form_chk ) == 0 || !is_array( $form_chk ) || count( $form_chk ) == 0 ){
				echo json_encode(
					array(
						'success' => false,
						'message' => 'url',
						'location' => admin_url( 'admin.php?page=ARForms-Mailster&err=1' )
					)
				);
				die;
			} else {
				$arf_mymail_form = esc_attr( $_REQUEST['arf_mymail_form'] );

				$form_data = $arfform->getOne( $_REQUEST['form_id'] );

				$new_values['form_name'] = $form_data->name;

				$options['arf_mymail_form'] = esc_attr( $_REQUEST['arf_mymail_form'] );

				$options['arf_mymail_arform_form'] = esc_attr( $_REQUEST['arf_mymail_arform_form'] );

				$options['arf_mymail_list'] = esc_attr( $_REQUEST['arf_mymail_list'] );

				$options['arf_mymaillist_checkbox'] = isset( $_REQUEST['arf_mymaillist_checkbox'] ) ? $_REQUEST['arf_mymaillist_checkbox'] : '';
				$options['arf_mymail_front_list'] = esc_attr( $_REQUEST['arf_mymail_front_list'] );

				$options['arf_mymail_list_selection'] = isset( $_REQUEST['arf_mymail_list_selection'] ) ? esc_attr( $_REQUEST['arf_mymail_list_selection'] ) : 'manual';

				$options['arf_mymailfrontlist_checkbox_all'] = isset( $_REQUEST['arf_mymailfrontlist_checkbox_all'] ) ? esc_attr( $_REQUEST['arf_mymailfrontlist_checkbox_all'] ) : '';

				if( 'all' != $options['arf_mymailfrontlist_checkbox_all'] ){
					$options['arf_mymaillist_checkbox'] = isset( $_REQUEST['arf_mymaillist_checkbox'] ) ? $_REQUEST['arf_mymaillist_checkbox'] : '';
				}

				$options['arf_mymailfrontlist_checkbox'] = isset( $_REQUEST['arf_mymailfrontlist_checkbox'] ) ? $_REQUEST['arf_mymailfrontlist_checkbox'] : '';

				if ( count( $mymail_forms[ $arf_mymail_form ]['order'] ) > 0 ) {
					foreach ( $mymail_forms[ $arf_mymail_form ]['order'] as $key => $value ) {
						$options[ 'arf_mymail_' . $value ] = esc_attr( $_REQUEST[ 'arf_mymail_' . $value ] );
					}
				}

				$form_options = maybe_unserialize( $form_data->options );
				$new_form_options = maybe_serialize( $form_options );

				$form_arf_mapped_addon = maybe_unserialize( $form_data->arf_mapped_addon );
				if ( isset( $form_arf_mapped_addon['arf_mapped_addon'] ) && ! empty( $form_arf_mapped_addon['arf_mapped_addon'] ) ) {
					if ( ! in_array( 'mailster', $form_arf_mapped_addon['arf_mapped_addon'] ) ) {
						array_push( $form_arf_mapped_addon['arf_mapped_addon'], 'mailster' );
					}
				} else {
					$form_arf_mapped_addon = array();
					$form_arf_mapped_addon['arf_mapped_addon'] = array( 'mailster' );
				}
				$new_form_arf_mapped_addon = maybe_serialize( $form_arf_mapped_addon );
				$wpdb->update(
					$arf_forms_tbl,
					array(
						'options' => $new_form_options,
						'arf_mapped_addon' => $new_form_arf_mapped_addon,
					),
					array( 'id' => $form_data->id )
				);

				$new_values['options'] = maybe_serialize( $options );

				$res = $wpdb->update( $arf_my_mail_forms_tbl, $new_values, array( 'id' => $id ) );

				$arfaction = 'edit';

				$message = esc_html__( 'Configuration saved successfully.', 'ARForms-MyMail' );

				echo json_encode(
					array(
						'success' => true,
						'message' => $message,
						'arfaction' => $arfaction,
					)
				);
				die;
			}
		} else {
			if( isset( $_REQUEST['arf_mymail_arform_form'] ) && '' != $_REQUEST['arf_mymail_arform_form'] ){

				$new_form_id = $_REQUEST['arf_mymail_arform_form'];

				$arf_mymail_form = esc_attr( $_REQUEST['arf_mymail_form'] );

				$form_data = $arfform->getOne( $new_form_id );

				$new_values['form_id'] = $new_form_id;

				$new_values['form_name'] = $form_data->name;

				$options['arf_mymail_form'] = $arf_mymail_form;

				$options['arf_mymail_arform_form'] = esc_attr( $_REQUEST['arf_mymail_arform_form'] );

				$options['arf_mymail_list'] = esc_attr( $_REQUEST['arf_mymail_list'] );

				$options['arf_mymail_list_selection'] = isset( $_REQUEST['arf_mymail_list_selection'] ) ? esc_attr( $_REQUEST['arf_mymail_list_selection'] ) : 'manual';

				$options['arf_mymailfrontlist_checkbox_all'] = isset( $_REQUEST['arf_mymailfrontlist_checkbox_all'] ) ? esc_attr( $_REQUEST['arf_mymailfrontlist_checkbox_all'] ) : '';

				if( 'all' != $options['arf_mymailfrontlist_checkbox_all'] ){
					$options['arf_mymaillist_checkbox'] = isset( $_REQUEST['arf_mymaillist_checkbox'] ) ? $_REQUEST['arf_mymaillist_checkbox'] : '';
				}

				$options['arf_mymail_front_list'] = esc_attr( $_REQUEST['arf_mymail_front_list'] );

				$options['arf_mymailfrontlist_checkbox'] = isset( $_REQUEST['arf_mymailfrontlist_checkbox'] ) ? $_REQUEST['arf_mymailfrontlist_checkbox'] : '';

				if ( count( $mymail_forms[ $arf_mymail_form ]['order'] ) > 0 ) {
					foreach ( $mymail_forms[ $arf_mymail_form ]['order'] as $key => $value ) {
						$options[ 'arf_mymail_' . $value ] = esc_attr( $_REQUEST[ 'arf_mymail_' . $value ] );
					}
				}

				$form_options = maybe_unserialize( $form_data->options );

				$new_form_options = maybe_serialize( $form_options );

				$form_arf_mapped_addon = maybe_unserialize( $form_data->arf_mapped_addon );
				if ( isset( $form_arf_mapped_addon['arf_mapped_addon'] ) && ! empty( $form_arf_mapped_addon['arf_mapped_addon'] ) ) {
					if ( ! in_array( 'mailster', $form_arf_mapped_addon['arf_mapped_addon'] ) ) {
						array_push( $form_arf_mapped_addon['arf_mapped_addon'], 'mailster' );
					}
				} else {
					$form_arf_mapped_addon = array();
					$form_arf_mapped_addon['arf_mapped_addon'] = array( 'mailster' );
				}
				$new_form_arf_mapped_addon = maybe_serialize( $form_arf_mapped_addon );
				$wpdb->update(
					$arf_forms_tbl,
					array(
						'options' => $new_form_options,
						'arf_mapped_addon' => $new_form_arf_mapped_addon,
					),
					array( 'id' => $form_data->id )
				);

				$new_values['options'] = maybe_serialize( $options );

				$new_values['created_at'] = current_time( 'mysql' );

				$id = $wpdb->insert( $arf_my_mail_forms_tbl, $new_values );

				$id = $wpdb->insert_id;

				$values = array();

				$values = $new_values;

				$values['id'] = $id;

				unset( $values['options'] );

				foreach ( $options as $option_key => $option_val ) {
					$values[ $option_key ] = $option_val;
				}

				$arfaction = 'edit';

				$message = esc_html__( 'Configuration saved successfully.', 'ARForms-MyMail' );

				echo json_encode (
					array (
						'success' => true,
						'message' => $message,
						'arfaction' => 'new',
						'new_id' => $id,
						'form_id' => $new_form_id
					)
				);
			}
		}
		die;
	}

	function new_form_v3() {
		global $wpdb, $arfform, $arformsmymail,$arf_forms_tbl,$arf_my_mail_forms_tbl;
		if( file_exists( ARF_MYMAIL_DIR . '/core/edit_3.0.php' ) ){
			require( ARF_MYMAIL_DIR . '/core/edit_3.0.php' );
		}
	}

	function arf_mymail_check_user_cap( $capability = '', $is_ajax = false ) {
		$errors = array();

		if ( $is_ajax == true && ! current_user_can( $capability ) ) {
			$msg = esc_html__( 'Sorry, you do not have permission to perform this action', 'ARForms-MyMail' );
			array_push( $errors, $msg );
			return json_encode( $errors );
		}

		$wpnonce = isset( $_REQUEST['_wpnonce_mymail'] ) ? $_REQUEST['_wpnonce_mymail'] : '';

		$arf_mymail_nonce_flag = wp_verify_nonce( $wpnonce, 'wp_nonce_mymail' );

		if ( ! $arf_mymail_nonce_flag ) {
			$msg = esc_html__( 'Sorry, your request cannot be processed due to security reason.', 'ARForms-MyMail' );
			array_push( $errors, $msg );
			return json_encode( $errors );
		}

		return 'success';
	}

	function arf_mymail_fields_check_drawoutside( $check = false, $field ) {
		global $wpdb,$arf_my_mail_forms_tbl;
		$form_id = $field['form_id'];
		$field_id = $field['id'];

		if ( isset( $GLOBALS['arf_form_mailster_not_set'][ $form_id ] ) ) {
			return $check;
		}
		if ( ! isset( $GLOBALS['arf_form_mailster_form_data'][ $form_id ] ) ) {
			$data = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' WHERE form_id =%d ', $form_id ) );
			if ( ! empty( $data ) ) {
				$opt = maybe_unserialize( $data[0]->options );

				if ( $opt['arf_mymail_list_selection'] == 'field' && $opt['arf_mymail_front_list'] == $field['id'] ) {
					$check = true;
				}
			}
		} else {
			$data = $GLOBALS['arf_form_mailster_form_data'][ $form_id ];
			if ( ! empty( $data ) ) {
				$opt = maybe_unserialize( $data->options );
				
				if ( $opt['arf_mymail_list_selection'] == 'field' && $opt['arf_mymail_front_list'] == $field['id'] ) {
					$check = true;
				}
			}
		}

		return $check;
	}

	function arf_mymail_field_drawfieldvalue_v3( $return_string, $field, $arf_on_chnage_function, $arf_data_uniq_id ) {
		global $wpdb, $arformsmymail,$arfieldhelper,$arf_my_mail_forms_tbl,$arfieldcontroller;
		$field_id = $field['id'];
		$form_id = $field['form_id'];
		if ( isset( $GLOBALS['arf_form_mailster_not_set'][ $form_id ] ) ) {
			return $return_string;
		}
		if ( ! isset( $GLOBALS['arf_form_mailster_form_data'][ $form_id ] ) ) {
			$data = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' WHERE form_id = %d', $form_id ) );
			if ( ! empty( $data ) ) {
				$opt = maybe_unserialize( $data[0]->options );
			}
		} else {
			$data = $GLOBALS['arf_form_mailster_form_data'][ $form_id ];
			if ( ! empty( $data ) ) {
				$opt = maybe_unserialize( $data->options );
			}
		}

		if ( ! empty( $data ) ) {

			$field_name = "item_meta[$field_id]";

			if ( $opt['arf_mymail_front_list'] == $field['id'] && $opt['arf_mymail_front_list'] != '' ) {

				$is_format = '';
				$value = $field['value'];
				$get_my_mail_lists = array();
				$selected_list = $opt['arf_mymailfrontlist_checkbox'];
				if (empty($selected_list)) {
					$get_my_mail_lists = $arformsmymail->get_my_mail_lists();
				}else{
					foreach ($selected_list as $value) {
						$get_my_mail_lists[] = mailster( 'lists' )->get($value);
					}
				}
				if ( count( $get_my_mail_lists ) > 0 ) {
					$is_format = 1;
				}

				$inline_css_with_style_tag = '';
				$inline_css_without_style = '';

				$defaults = array(
					'field' => 0,
					'field_name' => false,
					'opt_key' => 0,
					'opt' => '',
					'type' => $field['type'],
					'value' => false,
					'exclude' => 0,
					'hide_id' => false,
				);
				$onchange = $arf_on_chnage_function;
				$sanitized_name = ( isset( $field['id'] ) ) ? $field['id'] . '-0' : 'standard-0';
				$arf_input_field_html = '';
				$arf_input_field_html .= $arfieldcontroller->input_fieldhtml( $field, false );
				$arf_input_field_html .= $arfieldcontroller->input_html( $field, false );
				if ( $field['type'] == 'checkbox' ) {
					if ( $is_format == 1 ) {
						$cntr = 0;
						$arf_chk_counter = 1;
						if ( isset( $field['align'] ) && $field['align'] == 'arf_col_2' ) {
							$return_string .= '<div class="arf_chk_radio_col_two">';
						} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_3' ) {
							$return_string .= '<div class="arf_chk_radio_col_thiree">';
						} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_4' ) {
							$return_string .= '<div class="arf_chk_radio_col_four">';
						}
						foreach ( $get_my_mail_lists as $key => $format ) {
							if ( is_array( $value ) ) {
								$checked = ( in_array( $format->ID, $value ) ) ? 'checked="checked" ' : '';
							} else if ( $format->ID == $value ) {
								$checked = 'checked="checked" ';
							} else {
								$checked = '';
							}
							$class = '';

							$sanitized_name = ( isset( $field['id'] ) ) ? $field['id'] . '-' . $cntr : $format->ID . '-' . $cntr;

							$return_string .= '<div class="arf_checkbox_style" id="frm_checkbox_' . $field['id'] . '">';
							$_REQUEST['arfaction'] = ( isset( $_REQUEST['arfaction'] ) ) ? $_REQUEST['arfaction'] : '';
							$return_string .= "<div class='arf_checkbox_input_wrapper'>";
							$return_string .= '<input type="checkbox" name="' . $field_name . '[]" id="field_' . $sanitized_name . '" value="' . $format->ID . '"';

							$return_string .= $arf_input_field_html;
							if ( $key == 0 ) {
								if ( isset( $field['required'] ) and $field['required'] ) {
									$return_string .= 'data-validation-minchecked-minchecked="1" data-validation-minchecked-message="' . esc_attr( $field['blank'] ) . '"';
								}
							}

							if ( isset( $_REQUEST['arfaction'] ) && $_REQUEST['arfaction'] == 'preview' ) {
								$return_string .= $arf_on_chnage_function;
							}

							$return_string .= " {$arf_on_chnage_function} />";
							$return_string .= '<span>';
							if ( $GLOBALS['arf_form_data'][ $field['form_id'] ]->form_css['arfcheckradiostyle'] == 'custom' ) {
								$custom_checkbox = $GLOBALS['arf_form_data'][ $field['form_id'] ]->form_css['arf_checked_checkbox_icon'];
								$return_string .= "<i class='arfa {$custom_checkbox}'></i>";
							}
							$return_string .= '</span>';
							$return_string .= '</div>';
							$return_string .= '<label for="field_' . $sanitized_name . '" >';
							$return_string .= ucwords( $format->name );

							$return_string .= '</label>';

							$return_string .= '</div>';
							if ( isset( $field['align'] ) && $field['align'] == 'arf_col_2' ) {
								if ( $arf_chk_counter % 2 == 0 ) {
									$return_string .= '</div><div class="arf_chk_radio_col_two">';
								}
							} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_3' ) {
								if ( $arf_chk_counter % 3 == 0 ) {
									$return_string .= '</div><div class="arf_chk_radio_col_thiree">';
								}
							} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_4' ) {
								if ( $arf_chk_counter % 4 == 0 ) {
									$return_string .= '</div><div class="arf_chk_radio_col_four">';
								}
							}
							$cntr++;
							$arf_chk_counter++;
						}
						if ( isset( $field['align'] ) && ( $field['align'] == 'arf_col_2' || $field['align'] == 'arf_col_3' || $field['align'] == 'arf_col_4' ) ) {
							$return_string .= '</div>';
						}
					}
				}
				if ( $field['type'] == 'radio' ) {
					if ( $is_format == 1 ) {
						$cntr = 0;
						$arf_chk_counter = 1;
						if ( isset( $field['align'] ) && $field['align'] == 'arf_col_2' ) {
							$return_string .= '<div class="arf_chk_radio_col_two">';
						} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_3' ) {
							$return_string .= '<div class="arf_chk_radio_col_thiree">';
						} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_4' ) {
							$return_string .= '<div class="arf_chk_radio_col_four">';
						}
						foreach ( $get_my_mail_lists as $key => $format ) {
							if ( is_array( $value ) ) {
								$checked = ( in_array( $format->ID, $value ) ) ? 'checked="checked" ' : '';
							} else if ( $format->ID == $value ) {
								$checked = 'checked="checked" ';
							} else {
								$checked = '';
							}
							$class = '';

							$sanitized_name = ( isset( $field['id'] ) ) ? $field['id'] . '-' . $cntr : $format->ID . '-' . $cntr;

							$return_string .= '<div class="arf_radiobutton">';
							$_REQUEST['arfaction'] = ( isset( $_REQUEST['arfaction'] ) ) ? $_REQUEST['arfaction'] : '';
							$return_string .= "<div class='arf_radio_input_wrapper'>";
							$return_string .= '<input type="radio" name="' . $field_name . '[]" id="field_' . $sanitized_name . '" value="' . $format->ID . '"';

							$return_string .= $arf_input_field_html;
							if ( $key == 0 ) {
								if ( isset( $field['required'] ) and $field['required'] ) {
									$return_string .= 'data-validation-minchecked-minchecked="1" data-validation-minchecked-message="' . esc_attr( $field['blank'] ) . '"';
								}
							}

							if ( isset( $_REQUEST['arfaction'] ) && $_REQUEST['arfaction'] == 'preview' ) {
								$return_string .= $arf_on_chnage_function;
							}

							$return_string .= " {$arf_on_chnage_function} />";
							$return_string .= '<span>';
							if ( $GLOBALS['arf_form_data'][ $field['form_id'] ]->form_css['arfcheckradiostyle'] == 'custom' ) {
								$custom_radio = $GLOBALS['arf_form_data'][ $field['form_id'] ]->form_css['arf_checked_radio_icon'];
								$return_string .= "<i class='arfa {$custom_radio}'></i>";
							}
							$return_string .= '</span>';
							$return_string .= '</div>';
							$return_string .= '<label for="field_' . $sanitized_name . '" >';
							$return_string .= ucwords( $format->name );

							$return_string .= '</label>';

							$return_string .= '</div>';

							if ( isset( $field['align'] ) && $field['align'] == 'arf_col_2' ) {
								if ( $arf_chk_counter % 2 == 0 ) {
									$return_string .= '</div><div class="arf_chk_radio_col_two">';
								}
							} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_3' ) {
								if ( $arf_chk_counter % 3 == 0 ) {
									$return_string .= '</div><div class="arf_chk_radio_col_thiree">';
								}
							} else if ( isset( $field['align'] ) && $field['align'] == 'arf_col_4' ) {
								if ( $arf_chk_counter % 4 == 0 ) {
									$return_string .= '</div><div class="arf_chk_radio_col_four">';
								}
							}
							$cntr++;
							$arf_chk_counter++;
						}
						if ( isset( $field['align'] ) && ( $field['align'] == 'arf_col_2' || $field['align'] == 'arf_col_3' || $field['align'] == 'arf_col_4' ) ) {
							$return_string .= '</div>';
						}
					}
				} else if ( $field['type'] == 'select' ) {
					$defaults = array(
						'field' => 0,
						'field_name' => false,
						'opt_key' => 0,
						'opt' => '',
						'type' => 'select',
						'value' => false,
						'exclude' => 0,
						'hide_id' => false,
					);

					$onchange = '';

					$return_string .= '<select name="' . $field_name . '" ';

					if ( isset( $field['required'] ) and $field['required'] ) {
						$return_string .= ' data-validation-required-message="' . esc_attr( $field['blank'] ) . '"';
					}
					$return_string .= ' id="field_' . $field['field_key'] . '" ';

					$return_string .= $arfieldcontroller->input_fieldhtml( $field, false );
					$return_string .= $arfieldcontroller->input_html( $field, false );
					
					$return_string .= ' data-size="15" class="select_controll_' . $field['id'] . '" >';
					$return_string .= '<option value="">' . esc_html__( 'Please Select', 'ARForms-MyMail' ) . '</option>';

					if ( $is_format == 1 ) {
						foreach ( $get_my_mail_lists as $key => $format ) {
							$selected = '';

							if ( is_array( $value ) ) {
								$selected = ( in_array( $format->ID, $value ) ) ? 'selected="selected" ' : '';
							} else if ( $format->ID == $value ) {
								$selected = 'selected="selected" ';
							} else {
								$selected = '';
							}

								 $return_string .= '<option value="' . $format->ID . '" ' . $selected . ' >' . ucwords( $format->name ) . '</option>';

						}
					}

					$return_string .= '</select>';
				}
			}
		}
		return $return_string;
	}

	function arf_set_front_css(){
		global $arformsmymail_assets_version;
		$src = ARF_MYMAIL_URL.'/css/arformsmymail-front.css';
		wp_register_style( 'arformsmymail-front-css', $src, array(), $arformsmymail_assets_version );
	}

	function arf_before_form_render_v3( $arf_form, $form = '0' ) {
		global $wpdb,$arf_my_mail_forms_tbl;

		$form_id2 = $form->id;
		$form_mapped = maybe_unserialize( $form->arf_mapped_addon );
		if ( isset( $form_mapped ) && ! empty( $form_mapped ) ) {
			$form_mapped = $form_mapped['arf_mapped_addon'];
			if ( ! in_array( 'mailster', $form_mapped ) ) {
				$GLOBALS['arf_form_mailster_not_set'][ $form_id2 ] = true;
				return $arf_form;
			}
		} else if ( empty( $form_mapped ) ) {
			$GLOBALS['arf_form_mailster_not_set'][ $form_id2 ] = true;
			return $arf_form;
		}
		$form_data2 = array();
		if ( ! isset( $GLOBALS['arf_form_mailster_not_set'][ $form_id2 ] ) ) {
			$form_data2 = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' WHERE form_id = %d', $form_id2 ) );
		}

		if ( count( $form_data2 ) < 1 ) {
			$GLOBALS['arf_form_mailster_not_set'][ $form_id2 ] = true;
			return $arf_form;
		} else {
			$GLOBALS['arf_form_mailster_form_data'][ $form_id2 ] = $form_data2[0];
		}

		$form_data2 = $form_data2[0];

		$form_options = maybe_unserialize( $form_data2->options );

		if ( ! isset( $form_options['arf_mymail_form'] ) or empty( $form_options['arf_mymail_arform_form'] ) ) {
			return $arf_form;
		}

		$arf_form .= '<div id="arf_message_error" class="frm_error_style arf_mlstr_frm_error"><div class="msg-detail"><div class="msg-description-success">' . esc_html__( 'Something Wrong while submiting form.', 'ARForms-MyMail' ) . '</div></div></div>';

		wp_enqueue_style( 'arformsmymail-front-css' );

		$arf_mailster_css = '.ar_main_div_'.$form_id2.' .frm_error_style.arf_mlstr_frm_error{ display:none; }';
		wp_add_inline_style( 'arformsmymail-front-css', $arf_mailster_css );

		return $arf_form;

	}

	function arfmymail_validate_process( $flag, $form ) {
		global $wpdb, $arformsmymail,$arf_my_mail_forms_tbl;

		$form_id = $form->id;
		if ( isset( $GLOBALS['arf_form_mailster_not_set'][ $form_id ] ) ) {
			return $flag;
		}
		if ( ! isset( $GLOBALS['arf_form_mailster_form_data'][ $form_id ] ) ) {
			$form_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' WHERE form_id = %d', $form_id ) );
			if ( ! $form_data ) {
				return $flag;
			}
		} else {
			$form_data = $GLOBALS['arf_form_mailster_form_data'][ $form_id ];
		}

		$form_options = maybe_unserialize( $form_data->options );

		$arf_mymail_form = $form_options['arf_mymail_form'];

		$mymail_forms = $arformsmymail->get_my_mail_forms();

		$counter = 0;
		if ( count( $mymail_forms[ $arf_mymail_form ]['order'] ) > 0 ) {
			foreach ( $mymail_forms[ $arf_mymail_form ]['order'] as $key => $value ) {
				if ( $form_options[ 'arf_mymail_' . $value ] == '' && in_array( $value, $mymail_forms[ $arf_mymail_form ]['required'] ) ) {
					$counter++;
					break;
				}
			}
		}

		if ( $counter == 0 ) {
			return true;
		}

		return $flag;
	}

	function arf_prevalidate_fields( $arf_errors, $form_id, $values, $arf_form_data = array() ) {
		global $wpdb, $arfrecordmeta, $arfsettings, $current_user, $arffield, $arformsmymail,$arf_my_mail_forms_tbl;

		$form_data = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM  ' . $arf_my_mail_forms_tbl . ' WHERE form_id = %d', $form_id ) );

		if ( count( $form_data ) < 1 ) {
			return $arf_errors;
		}

		$form_data = $form_data[0];

		$form_options = maybe_unserialize( $form_data->options );

		$arf_mymail_form = $form_options['arf_mymail_form'];

		$mymail_forms = $arformsmymail->get_my_mail_forms();

		$counter = 0;
		if ( count( $mymail_forms[ $arf_mymail_form ]['order'] ) > 0 ) {
			foreach ( $mymail_forms[ $arf_mymail_form ]['order'] as $key => $value ) {
				if ( $form_options[ 'arf_mymail_' . $value ] == '' && in_array( $value, $mymail_forms[ $arf_mymail_form ]['required'] ) ) {
					$counter++;
					break;
				}
			}
		}

		if ( $counter > 0 ) {
			return $arf_errors;
		}

		if ( isset( $values['item_meta'] ) && $values['item_meta'] ) {
			foreach ( $values['item_meta'] as $field_id => $field_value ) {
				if ( count( $mymail_forms[ $arf_mymail_form ]['order'] ) > 0 ) {
					foreach ( $mymail_forms[ $arf_mymail_form ]['order'] as $key => $value ) {
						if ( $form_options[ 'arf_mymail_' . $value ] == $field_id && in_array( $value, $mymail_forms[ $arf_mymail_form ]['required'] ) && $field_value == '' ) {
							$arf_errors[ $field_id ] = esc_html__( 'This field cannot be blank.', 'ARForms-MyMail' );
						} else if ( $form_options['arf_mymail_list'] == $field_id && $form_options['arf_mymail_list'] != '' && $field_value == '' ) {
							$arf_errors[ $field_id ] = esc_html__( 'This field cannot be blank.', 'ARForms-MyMail' );
						} else if ( ( ! array_key_exists( $form_options[ 'arf_mymail_' . $value ], $values['item_meta'] ) ) && in_array( $value, $mymail_forms[ $arf_mymail_form ]['required'] ) ) {

							$field_option_value_get = $arffield->getOne( $form_options[ 'arf_mymail_' . $value ] );
							if ( $field_option_value_get->type == 'radio' ) {
								if ( ! array_key_exists( 'arf_mymail_' . $value, $arf_errors ) ) {
									$arf_errors[ $form_options[ 'arf_mymail_' . $value ] ] = esc_html__( 'This field cannot be blank.', 'ARForms-MyMail' );
								}
							} else if ( $field_option_value_get->type == 'checkbox' ) {
								if ( ! array_key_exists( 'arf_message_error', $arf_errors ) ) {
									$arf_errors['arf_message_error'] = esc_html__( 'Please Select', 'ARForms-MyMail' ) . ' ' . $field_option_value_get->name;
								}
							}
						} else if ( ( ! array_key_exists( $form_options['arf_mymail_list'], $values['item_meta'] ) ) && $form_options['arf_mymail_list'] != '' ) {
							$field_option_value_get = $arffield->getOne( $form_options['arf_mymail_list'] );
							if ( $field_option_value_get->type == 'radio' ) {
								if ( ! array_key_exists( $form_options['arf_mymail_list'], $arf_errors ) ) {
									$arf_errors[ $form_options['arf_mymail_list'] ] = esc_html__( 'This field cannot be blank.', 'ARForms-MyMail' );
								}
							} else if ( $field_option_value_get->type == 'checkbox' ) {
								if ( ! array_key_exists( 'arf_message_error', $arf_errors ) ) {
									$arf_errors['arf_message_error'] = esc_html__( 'Please Select', 'ARForms-MyMail' ) . ' ' . $field_option_value_get->name;
								}
							}
						}
					}
				}
			}
		}

		return $arf_errors;
	}

	function arf_mailster_after_paypal_submit( $form_id, $entry_id, $txn_id ){
		$this->after_submit_form( $entry_id, $form_id );
	}

	function after_submit_form( $entry_id, $form_id ) {
		global $arfrecordmeta, $wpdb, $arfsettings, $arformsmymail, $arf_mymail_subscribers,$arf_my_mail_forms_tbl;
		$entry_ids = array( $entry_id );
		$values = $arfrecordmeta->getAll( 'it.field_id != 0 and it.entry_id in (' . implode( ',', $entry_ids ) . ')', ' ORDER BY fi.id' );

		$get_mapped_form = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' WHERE form_id=%d', $form_id ) );
		$result = count( $get_mapped_form );

		if ( $result > 0 ) {
			$options = maybe_unserialize( $get_mapped_form[0]->options );

			$posted_values = $values;

			$arf_mymail_form = $options['arf_mymail_form'];

			$arf_mymail_arform_form = $options['arf_mymail_arform_form'];

			$arf_mymail_list = $options['arf_mymail_list'];

			$arf_mymail_front_list = $options['arf_mymail_front_list'];

			$arf_mymailfrontlist_checkbox = $options['arf_mymailfrontlist_checkbox'];

			$mailchimp_list_selection = $options['arf_mymail_list_selection'];

			$arf_mymaillist_checkbox = '';
			if ( $arf_mymail_list == '' ) {
				$arf_mymaillist_checkbox = $options['arf_mymaillist_checkbox'];
			}

			$mymail_forms = $arformsmymail->get_my_mail_forms();

			$total_mymail_forms_field = count( $mymail_forms[ $arf_mymail_form ]['order'] );

			$mymail_field_val = array();
			$mymail_list_val = '';
			$mymail_front_list_val = '';
			foreach ( $values as $value ) {
				if ( $total_mymail_forms_field > 0 ) {
					foreach ( $mymail_forms[ $arf_mymail_form ]['order'] as $key => $mymail_value ) {
						if ( $options[ 'arf_mymail_' . $mymail_value ] == $value->field_id ) {
							$mymail_field_val[ $mymail_value ] = $value->entry_value;
						}
					}
				}
				if ( $arf_mymail_list == $value->field_id && $arf_mymail_list != '' ) {
					$mymail_list_val = $value->entry_value;
				}
				if ( $arf_mymail_front_list == $value->field_id && $arf_mymail_front_list != '' && 'field' == $mailchimp_list_selection ) {
					$mymail_front_list_val = $value->entry_value;
				}
			}


			if ( count( $mymail_field_val ) > 0 ) {
				$current_time = time();

				$ip_signup = $_SERVER['REMOTE_ADDR'];

				$entry_referer = $_SERVER['HTTP_REFERER'];

				if ( isset( $mymail_forms[ $arf_mymail_form ]['double_opt_in'] ) && $mymail_forms[ $arf_mymail_form ]['double_opt_in'] == 1 ) {
					$mymail_field_val_status = 0;
				} else {
					$mymail_field_val_status = 1;
				}

				$mymail_list_val_value = maybe_unserialize( $mymail_list_val );
				if ( ! is_array( $mymail_list_val_value ) ) {
					$mymail_list_val_value = array( $mymail_list_val_value );
				}
				if ( is_array( $arf_mymaillist_checkbox ) ) {
					$mymail_list_val_value = $arf_mymaillist_checkbox;
				}
				
				$mymail_front_list_val_value = maybe_unserialize( $mymail_front_list_val );
				if ( ! is_array( $mymail_front_list_val_value ) && !empty($mymail_front_list_val_value) ) {
					$mymail_front_list_val_value = array( $mymail_front_list_val_value );
				}
				if ( is_array( $arf_mymailfrontlist_checkbox ) && !empty($arf_mymailfrontlist_checkbox) && 'field' == $mailchimp_list_selection ) {
					$mymail_front_list_val_value = $arf_mymailfrontlist_checkbox;
				}

				$overwrite = true;
				$mailster_version = $this->arf_get_mailster_data();
				
				$final_mymail_list = ( isset( $mymail_front_list_val_value ) && !empty( $mymail_front_list_val_value) ) ? $mymail_front_list_val_value : $mymail_list_val_value;
				if ( version_compare( $mailster_version, '2.3', '<' ) ) {

					mymail_subscribe( $mymail_field_val['email'], $mymail_field_val,$final_mymail_list, $mymail_list_val_value,  isset( $mymail_forms[ $arf_mymail_form ]['double_opt_in'] ) ? $mymail_forms[ $arf_mymail_form ]['double_opt_in'] : '', $overwrite, isset( $mergelists ) ? $mergelists : '', isset( $template ) ? $template : '' );
				} else {
					mailster_subscribe( $mymail_field_val['email'], $mymail_field_val, $final_mymail_list, isset( $mymail_forms[ $arf_mymail_form ]['double_opt_in'] ) ? $mymail_forms[ $arf_mymail_form ]['double_opt_in'] : '', $overwrite, isset( $mergelists ) ? $mergelists : '', isset( $template ) ? $template : '' );
				}
			}
		} else {
			return;
		}
	}

	function check_mymail_field_value( $type, $value, $custom_fields_flag = false ) {

		global $wpdb,$mymail_subscribers_tbl;

		$value = esc_sql( $value );

		$query = 'SELECT a.*';

		$query .= ' FROM ' . $mymail_subscribers_tbl . ' as a';
		$query .= " WHERE a.$type = '" . ( $value ) . "' LIMIT 1";

		if ( ! ( $flag_object = $wpdb->get_row( $query ) ) ) {
			return false;
		}

		return $flag_object;
	}

	function chk_mymail_list_value( $list_id, $subscriber_id ) {
		global $wpdb,$mymail_lists_subscribers_tbl;

		$query = $wpdb->preapre( 'SELECT * FROM ' . $mymail_lists_subscribers_tbl . " WHERE list_id='%d' AND subscriber_id='%d'", $list_id, $subscriber_id );

		if ( $flag_object = $wpdb->get_row( $query ) ) {
			return false;
		}

		return $flag_object;
	}

	function chk_mymail_meta_field_value( $meta_key, $subscriber_id ) {
		global $wpdb,$mymail_subscriber_fields_tbl;

		$query = $wpdb->prepare( 'SELECT * FROM ' . $mymail_subscriber_fields_tbl . " WHERE meta_key='%d' AND subscriber_id='%d'", $meta_key, $subscriber_id );
		if ( $flag_object = $wpdb->get_row( $query ) ) {
			return false;
		}

		return $flag_object;
	}

}


global $arf_mymail_api_url, $arf_mymail_plugin_slug;

$arf_mymail_api_url = $arformsmymail->arfmymail_getapiurl();
$arf_mymail_plugin_slug = basename( dirname( __FILE__ ) );

add_filter( 'pre_set_site_transient_update_plugins', 'arfmymail_check_for_plugin_update' );

function arfmymail_check_for_plugin_update( $checked_data ) {
	global $arf_mymail_api_url, $arf_mymail_plugin_slug, $wp_version, $arformsmymail, $arformsmymail_version;

	if ( empty( $checked_data->checked ) ) {
		return $checked_data;
	}

	$arfmymailhomeurl = home_url();

	$args = array(
		'slug' => $arf_mymail_plugin_slug,
		'version' => $arformsmymail_version,
		'other_variables' => $arformsmymail->arfmymail_get_remote_post_params(),
	);

	$request_string = array(
		'body' => array(
			'action' => 'basic_check',
			'request' => serialize( $args ),
			'api-key' => md5( $arfmymailhomeurl ),
		),
		'user-agent' => 'ARFMYMAIL-WordPress/' . $wp_version . '; ' . $arfmymailhomeurl,
	);

	$raw_response = wp_remote_post( $arf_mymail_api_url, $request_string );

	if ( ! is_wp_error( $raw_response ) && ( $raw_response['response']['code'] == 200 ) ) {
		$response = ( isset( $raw_response['body'] ) && ! empty( $raw_response['body'] ) ) ? maybe_unserialize( $raw_response['body'] ) : array();
	}

	if ( isset( $response ) && ! empty( $response ) && isset( $response->token ) && $response->token != '' ) {
		update_option( 'arfmymail_update_token', $response->token );
	}

	if ( isset( $response ) && is_object( $response ) && is_object( $checked_data ) && ! empty( $response ) ) {
		$checked_data->response[ $arf_mymail_plugin_slug . '/' . $arf_mymail_plugin_slug . '.php' ] = $response;
	}

	return $checked_data;
}

	add_filter( 'plugins_api', 'arfmymail_plugin_api_call', 10, 3 );

function arfmymail_plugin_api_call( $def, $action, $args ) {
	global $arf_mymail_plugin_slug, $arf_mymail_api_url, $wp_version;

	if ( ! isset( $args->slug ) || ( $args->slug != $arf_mymail_plugin_slug ) ) {
		return false;
	}

	$plugin_info = get_site_transient( 'update_plugins' );
	$current_version = $plugin_info->checked[ $arf_mymail_plugin_slug . '/' . $arf_mymail_plugin_slug . '.php' ];
	$args->version = $current_version;

	$arfmymailhomeurl = home_url();

	$request_string = array(
		'body' => array(
			'action' => $action,
			'update_token' => get_site_option( 'arfmymail_update_token' ),
			'request' => serialize( $args ),
			'api-key' => md5( $arfmymailhomeurl ),
		),
		'user-agent' => 'ARFMYMAIL-WordPress/' . $wp_version . '; ' . $arfmymailhomeurl,
	);

	$request = wp_remote_post( $arf_mymail_api_url, $request_string );

	if ( is_wp_error( $request ) ) {
		$res = new WP_Error( 'plugins_api_failed', esc_html__( '<p>An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a></p>', 'ARForms-MyMail' ), $request->get_error_message() );
	} else {
		$res = maybe_unserialize( $request['body'] );

		if ( $res === false ) {
			$res = new WP_Error( 'plugins_api_failed', esc_html__( 'An unknown error occurred', 'ARForms-MyMail' ), $request['body'] );
		}
	}

	return $res;
}
?>