<?php
global $wpdb, $db_record, $arformsmymail_version, $arf_forms_tbl, $arf_my_mail_forms_tbl;
$actions['bulk_delete'] = esc_html__( 'Delete', 'ARForms-MyMail' );
?>

<div id="success_message" class="arf_success_message">
	<div class="message_descripiton">
		<div id="success_msg_text"></div>
		<div class="message_svg_icon">
			<svg height="14px" stroke-width="14px">
				<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411 l1.616,1.613L6.392,14.407H6.075z"></path>
			</svg>
		</div>
	</div>
</div>

<div id="error_message" class="arf_error_message">
	<div class="message_descripiton">
		<div id="error_msg_text"></div>
		<div class="message_svg_icon">
			<svg height="14px" stroke-width="14px">
				<path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path>
			</svg>
		</div>
	</div>
</div>
<?php echo str_replace( 'id="{arf_id}"', 'id="arf_full_width_loader"', ARF_LOADER_ICON ); ?>
<div class="wrap mymail_page">
	<div class="top_bar">
		<span class="h2"><?php esc_html_e( 'Mailster Configuration', 'ARForms-MyMail' ); ?></span>
	</div>
	<div id="poststuff" class="metabox-holder">
		<div id="post-body">
			<div class="inside">
				<div class="frm_settings_form arf_mailster_list_wrapper wrap_content">
					<form name="arf_mymail_forms arf_mlstr_full_width" method="get" id="arf_mymail_forms" onsubmit="return arf_mymail_form_bulk_act();">
						<input type="hidden" name="_wpnonce_mymail" value="<?php echo wp_create_nonce( 'wp_nonce_mymail' ); ?>" />
						<div id="arf_mymail_forms">
							<div class="arf_newaction_rounded_blue_button">
								<button class="rounded_button arf_btn_dark_blue arf_mlstr_add_new_btn" type="button" onclick="location.href = '<?php echo admin_url( 'admin.php?page=ARForms-Mailster&arfaction=new' ); ?>';">
									<svg width="20px" height="20px">
										<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M16.997,7.32v2h-7v6.969h-2V9.32h-7v-2h7V0.289h2V7.32H16.997z"></path>
									</svg>&nbsp;<?php esc_html_e( 'Configure New Form', 'ARForms-MyMail' ); ?>
								</button>
							</div>

							<div class="alignleft actions">
								<?php $two = '1'; ?>
								<div class="">
									<div class="arf_list_bulk_action_wrapper">
										<input id="arf_bulk_action_one" name="action<?php echo esc_html( $two ); ?>" value="-1" type="hidden" />

										<dl class="arf_selectbox arf_mlstr_bulk_act_dd" data-name="action<?php echo esc_html( $two ); ?>" data-id="arf_bulk_action_one">
											<dt>
												<span><?php esc_html_e( 'Bulk Actions', 'ARForms-MyMail' ); ?></span>
												<svg viewBox="0 0 2000 1000" width="15px" height="15px">
													<g fill="#000">
														<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
													</g>
												</svg>
											</dt>
											<dd>
												<ul data-id="arf_bulk_action_one">
													<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-MyMail' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-MyMail' ); ?></li>
													<?php
													foreach ( $actions as $name => $title ) {
														$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
														?>
														<li <?php echo $class; ?> data-value='<?php echo esc_html( $name ); ?>' data-label='<?php echo esc_html($title); ?>'><?php echo esc_html( $title ); ?></li>
													<?php } ?>
												</ul>
											</dd>
										</dl>
									</div>
									<?php
										echo '<input type="submit" id="doaction' . $two . '" class="arf_bulk_action_btn rounded_button btn_green" value="' . esc_html__( 'Apply', 'ARForms-MyMail' ) . '" />';
										echo "\n";
									?>
								</div>
							</div>
							<table cellpadding="0" cellspacing="0" border="0" class="display table_grid" id="example">
								<thead>
									<tr>
										<th class="center">
											<div class="arf_custom_checkbox_div">
												<div class="arf_custom_checkbox_wrapper arf_mlstr_cb_select">
													<input id="cb-select-all-1" type="checkbox" class="">
													<svg width="18px" height="18px">
														<path id="arfcheckbox_unchecked" d="M15.205,16.852H3.774c-1.262,0-2.285-1.023-2.285-2.286V3.136  c0-1.263,1.023-2.286,2.285-2.286h11.431c1.263,0,2.286,1.023,2.286,2.286v11.43C17.491,15.829,16.467,16.852,15.205,16.852z   M15.49,2.851h-12v12h12V2.851z"></path>
														<path id="arfcheckbox_checked" d="M15.205,16.852H3.774c-1.262,0-2.285-1.023-2.285-2.286V3.136  c0-1.263,1.023-2.286,2.285-2.286h11.431c1.263,0,2.286,1.023,2.286,2.286v11.43C17.491,15.829,16.467,16.852,15.205,16.852z   M15.49,2.851h-12v12h12V2.851z M5.93,6.997l2.557,2.558l4.843-4.843l1.617,1.616l-4.844,4.843l0.007,0.007l-1.616,1.616  l-0.007-0.007l-0.006,0.007l-1.617-1.616l0.007-0.007L4.314,8.614L5.93,6.997z"></path>
													</svg>
												</div>
												<label for="cb-select-all-1"  class="cb-select-all"><span></span></label>
											</div>
										</th>
										<th class=""><?php esc_html_e( 'Form ID', 'ARForms-MyMail' ); ?></th>
										<th class=""><?php esc_html_e( 'Form Title', 'ARForms-MyMail' ); ?></th>
										<th class=""><?php esc_html_e( 'Entries', 'ARForms-MyMail' ); ?></th>
										<th class=""><?php esc_html_e( 'Created Date', 'ARForms-MyMail' ); ?></th>
										<th class="arf_col_action"><?php esc_html_e( 'Action', 'ARForms-MyMail' ); ?></th>
									</tr>
								</thead>
								<tbody>
									<?php
									$forms = $wpdb->get_results( 'SELECT * FROM ' . $arf_my_mail_forms_tbl . ' ORDER BY id DESC' );
									if ( count( $forms ) > 0 ) {
										foreach ( $forms as $form ) {
											$options = maybe_unserialize( $form->options );
											?>
											<tr>
												<td class="center">
													<div class="arf_custom_checkbox_wrapper arfmarginl15">
														<input id="cb-item-action-<?php echo esc_html($form->id); ?>" class="" type="checkbox" value="<?php echo esc_html( $form->id ); ?>" name="item-action[]" />
														<svg width="18px" height="18px">
															 <path id="arfcheckbox_unchecked" d="M15.205,16.852H3.774c-1.262,0-2.285-1.023-2.285-2.286V3.136  c0-1.263,1.023-2.286,2.285-2.286h11.431c1.263,0,2.286,1.023,2.286,2.286v11.43C17.491,15.829,16.467,16.852,15.205,16.852z   M15.49,2.851h-12v12h12V2.851z"></path>
															 <path id="arfcheckbox_checked" d="M15.205,16.852H3.774c-1.262,0-2.285-1.023-2.285-2.286V3.136  c0-1.263,1.023-2.286,2.285-2.286h11.431c1.263,0,2.286,1.023,2.286,2.286v11.43C17.491,15.829,16.467,16.852,15.205,16.852z   M15.49,2.851h-12v12h12V2.851z M5.93,6.997l2.557,2.558l4.843-4.843l1.617,1.616l-4.844,4.843l0.007,0.007l-1.616,1.616  l-0.007-0.007l-0.006,0.007l-1.617-1.616l0.007-0.007L4.314,8.614L5.93,6.997z"></path>
														 </svg>
													</div>
													   <label for="cb-item-action-<?php echo esc_html( $form->id ); ?>"><span></span></label>
												</td>
												<td><?php echo esc_html( $form->form_id ); ?></td>
												<td class="form_name">
													<a class="row-title" href="<?php echo wp_nonce_url( "?page=ARForms-Mailster&arfaction=edit&id={$form->id}" ); ?>">
													<?php echo $form->form_name; ?>
													</a>
												</td>
												<td class="form_entries center">
													<?php
													$entries = $db_record->getRecordCount( $form->form_id );
													echo ( current_user_can( 'arfviewentries' ) ) ? '<a href="' . esc_url( admin_url( 'admin.php' ) . '?page=ARForms-entries&form=' . $form->form_id ) . '">' . $entries . '</a>' : $entries;
													?>
												</td>
												<td><?php echo date( get_option( 'date_format' ), strtotime( $form->created_at ) ); ?></td>
												<td class="arf_action_cell">
													<div class="arf-row-actions">
														<?php
														$edit_link = "?page=ARForms-Mailster&arfaction=edit&id={$form->id}";
														echo "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Configuration', 'ARForms-MyMail' ) . "'><a href='" . wp_nonce_url( $edit_link ) . "'><svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'><path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path></svg></a></div>";
														echo "<div class='arfformicondiv arfhelptip arfdeleteform_div_" . $form->id . "' title='" . esc_html__( 'Delete', 'ARForms-MyMail' ) . "'><a class='arf_mailster_delete' onclick='arf_delete_mailster_entry(this);' data-id='" . $form->id . "'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";
														?>
													</div>
												</td>
											</tr>
											<?php
										}
									}
									?>
								</tbody>
							</table>
							<div class="clear"></div>
							<input type="hidden" name="show_hide_columns" id="show_hide_columns" value="<?php esc_html_e( 'Show / Hide columns', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="search_grid" id="search_grid" value="<?php esc_html_e( 'Search', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="entries_grid" id="entries_grid" value="<?php esc_html_e( 'entries', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="show_grid" id="show_grid" value="<?php esc_html_e( 'Show', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="showing_grid" id="showing_grid" value="<?php esc_html_e( 'Showing', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="to_grid" id="to_grid" value="<?php esc_html_e( 'to', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="of_grid" id="of_grid" value="<?php esc_html_e( 'of', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="no_match_record_grid" id="no_match_record_grid" value="<?php esc_html_e( 'No matching records found', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="no_record_grid" id="no_record_grid" value="<?php esc_html_e( 'No data available in table', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="filter_grid" id="filter_grid" value="<?php esc_html_e( 'filtered from', 'ARForms-MyMail' ); ?>"/>
							<input type="hidden" name="totalwd_grid" id="totalwd_grid" value="<?php esc_html_e( 'total', 'ARForms-MyMail' ); ?>"/>
							<div class="alignleft actions2">
								<?php $two = '2'; ?>
								<div class="alignleft actions2">
									<div class="arf_list_bulk_action_wrapper">
										<input id="arf_bulk_action_one" name="action<?php echo esc_html( $two ); ?>" value="-1" type="hidden" />
										<dl class="arf_selectbox arf_mlstr_bulk_act_dd" data-name="action<?php echo esc_html( $two ); ?>" data-id="arf_bulk_action_one">
											<dt>
												<span><?php esc_html_e( 'Bulk Actions', 'ARForms-MyMail' ); ?></span>
												<svg viewBox="0 0 2000 1000" width="15px" height="15px">
													<g fill="#000">
														<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
													</g>
												</svg>
											</dt>
											<dd>
												<ul data-id="arf_bulk_action_one">
													<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-MyMail' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-MyMail' ); ?></li>
													<?php
													foreach ( $actions as $name => $title ) {
														$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
														?>
														<li <?php echo $class; ?> data-value='<?php echo esc_html( $name ); ?>' data-label='<?php echo esc_html( $title ); ?>'><?php echo esc_html( $title ); ?></li>
													<?php } ?>
												</ul>
											</dd>
										</dl>
									</div>
									<?php
									echo '<input type="submit" id="doaction' . $two . '" class="arf_bulk_action_btn rounded_button btn_green" value="' . esc_html__( 'Apply', 'ARForms-MyMail' ) . '" />';
									echo "\n";
									?>
								</div>
							</div>
							<div class="footer_grid"></div>
						</div>
					</form>
				</div>
				<div id="delete_form_message" class="arfmodal arfhide arffade arfdeletemodabox">
					<div class="arfnewmodalclose" data-dismiss="arfmodal">
						<img src="<?php echo esc_url( ARFIMAGESURL . '/close-button.png' ); ?>" align="absmiddle" />
					</div>
					<input type="hidden" value="" id="delete_entry_id" />
					<div class="arfdelete_modal_title">
						<img src="<?php echo esc_url( ARFIMAGESURL . '/delete-field-icon.png' ); ?>" align="absmiddle" />&nbsp;<?php esc_html_e( 'DELETE', 'ARForms-MyMail' ); ?>
					</div>
					<div class="arfdelete_modal_msg"><?php esc_html_e( 'Are you sure you want to delete this configuration?', 'ARForms-MyMail' ); ?></div>
					<div class="arf_delete_modal_row">
						<div class="arf_delete_modal_left" onclick="arfmymailformactionfunc('delete','');">
							<img src="<?php echo esc_url( ARFIMAGESURL . '/okay-icon.png' ); ?>" align="absmiddle" />&nbsp;<?php esc_html_e( 'Okay', 'ARForms-MyMail' ); ?>
						</div>
						<div class="arf_delete_modal_right" data-dismiss="arfmodal">
							<img src="<?php echo esc_url( ARFIMAGESURL . '/cancel-btnicon.png' ); ?>" align="absmiddle" />&nbsp;<?php esc_html_e( 'Cancel', 'ARForms-MyMail' ); ?>
						</div>
					</div>
				</div>
				<div class="documentation_link" align="right">
					<a href="<?php echo esc_url( ARF_MYMAIL_URL.'/documentation/index.html' ); ?>" class="doc_link" target="_blank"><?php esc_html_e( 'MyMail Documentation', 'ARForms-MyMail' ); ?></a>|<a href="https://helpdesk.arpluginshop.com/submit-a-ticket/" class="support_link" target="_blank"><?php esc_html_e( 'Support', 'ARForms-MyMail' ); ?></a> &nbsp;&nbsp;
					<img src="<?php echo esc_url( ARFURL.'/images/dot.png' ); ?>" height="4" width="4" onclick="javascript:OpenInNewTab('<?php echo esc_url( ARFURL.'/documentation/assets/sysinfo.php' ); ?>');" />
				</div>
			</div>
		</div>
	</div>
</div>
<div class="arf_modal_overlay">
    <div id="delete_bulk_mailster_form_message" class="arfdeletemodabox arfmodal arf_popup_container arfdeletemodalboxnew">
        <input type="hidden" value="false" id="delete_bulk_entry_flag"/>
        
        <div class="arfdelete_modal_msg delete_confirm_message"><?php echo addslashes(sprintf(esc_html__('Are you sure you want to  %s delete selected Form(s)?','ARForms-MyMail'),'<br/>')); ?></div>

        <div class="arf_delete_modal_row delete_popup_footer">
            <button class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arf_delete_bulk_mailster_form('true');">&nbsp;<?php echo addslashes(esc_html__('Okay', 'ARForms-MyMail')); ?></button>&nbsp;&nbsp;
            <button class="arf_delete_modal_right rounded_button delete_button arfdelete_color_gray arf_bulk_delete_transaction_close_btn" data-dismiss="arfmodal">&nbsp;<?php echo addslashes(esc_html__('Cancel', 'ARForms-MyMail')); ?></button>
        </div>
    </div>
</div>